/* serial_matrix.c - Matriz serial */
#include <stdio.h>

#define NUMNOTAS 12

int  pitchClass(int MIDI);
int  normalizedPitchClass(int MIDI, int root);
void retrogradar(int fila[], int retro[]);
void trasponer(int fila[], int trasp[], int t);
void invertir(int fila[], int invert[]);
void retrogradarInvertir(int fila[], int reinv[]);
void serialMatrix(int fila[], int matriz[NUMNOTAS][]);

int main(){

	int pc, i, j;
	int midi[NUMNOTAS] = {55, 58, 62, 66, 69, 72, 76, 80, 83, 85, 87, 89};
	int secuencia[NUMNOTAS], secuenciaRetro[NUMNOTAS], secuenciaTrasp[NUMNOTAS];
	int secuenciaInv[NUMNOTAS], secuenciaReInv[NUMNOTAS], matriz[NUMNOTAS][NUMNOTAS];
	
	printf("Notas MIDI: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", midi[i]);
	}
	printf("\n");
	
	printf("Pitch classes: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", pitchClass(midi[i]));
	}
	printf("\n");

	printf("Normalized pitch classes: \n");
	for (i = 0; i < NUMNOTAS; i++){
		pc = normalizedPitchClass(midi[i], midi[0]);
		printf("%2d\t", pc); 
		secuencia[i] = pc;
	}
	printf("\n");
	printf("\n");
	
	
	serialMatrix(secuencia, matriz);
	
	printf("Matriz serial: \n");
	for (i = 0; i < NUMNOTAS; i++){
		for (j = 0; j < NUMNOTAS; j++){
			printf("%3d", matriz[i][j]);
		}
		printf("\n");
	}
	printf("\n");

	
	printf("Matriz serial 2: \n");
	for (i = 0; i < NUMNOTAS; i++){
		for (j = 0; j < NUMNOTAS; j++){
			printf("%3d", pitchClass(secuencia[j] - secuencia[i] + 12));
		}
		printf("\n");
	}
	printf("\n");

	
			
	return 0;
}

int pitchClass(int MIDI){
	
	return (MIDI % 12);
}

int normalizedPitchClass(int MIDI, int root){
	
	return ((MIDI - root) % 12);
}

void trasponer(int fila[], int trasp[], int t){
	int i;
	
	for (i = 0; i < NUMNOTAS; i++){
		trasp[i] = pitchClass((fila[i] + t));
	}
}

void invertir(int fila[], int invert[]){
	int i;
	
	for (i = 0; i < NUMNOTAS; i++){
		invert[i] = pitchClass((12 - fila[i]));
	}

}

void serialMatrix(int fila[], int matriz[][NUMNOTAS]){

	int i;
	int inv[NUMNOTAS], filaMatriz[NUMNOTAS];

	// inversion
	invertir(fila, inv);

	for (i = 0; i < NUMNOTAS; i++){
		trasponer(fila, matriz[i], inv[i]);
	}	
}
