/* serial_operations.c - Serial operations */
#include <stdio.h>

#define NUMNOTAS 12

int  pitchClass(int MIDI);
int  normalizedPitchClass(int MIDI, int root);
void retrogradar(int fila[], int retro[]);
void trasponer(int fila[], int trasp[], int t);
void invertir(int fila[], int invert[]);
void retrogradarInvertir(int fila[], int reinv[]);

int main(){

	int pc, i;
	int midi[NUMNOTAS] = {55, 58, 62, 66, 69, 72, 76, 80, 83, 85, 87, 89};
	int secuencia[NUMNOTAS], secuenciaRetro[NUMNOTAS], secuenciaTrasp[NUMNOTAS];
	int secuenciaInv[NUMNOTAS], secuenciaReInv[NUMNOTAS];
	
	printf("Notas MIDI: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", midi[i]);
	}
	printf("\n");
	
	printf("Pitch classes: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", pitchClass(midi[i]));
	}
	printf("\n");

	printf("Normalized pitch classes: \n");
	for (i = 0; i < NUMNOTAS; i++){
		pc = normalizedPitchClass(midi[i], midi[0]);
		printf("%2d\t", pc); 
		secuencia[i] = pc;
	}
	printf("\n");
	
	
	// Operaciones:
	retrogradar(secuencia, secuenciaRetro);
	trasponer(secuencia, secuenciaTrasp, 3);
	invertir(secuencia, secuenciaInv);
	retrogradarInvertir(secuencia, secuenciaReInv);

	printf("Secuencia retrogradada: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", secuenciaRetro[i]); 
	}
	printf("\n");
	printf("Secuencia traspuesta: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", secuenciaTrasp[i]); 
	}
	printf("\n");
	printf("Secuencia invertida: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", secuenciaInv[i]); 
	}
	printf("\n");
	printf("Secuencia retrogradada invertida: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", secuenciaReInv[i]); 
	}
	printf("\n");
	
	
	return 0;
}

int pitchClass(int MIDI){
	
	return (MIDI % 12);
}

int normalizedPitchClass(int MIDI, int root){
	
	return ((MIDI - root) % 12);
}

void retrogradar(int fila[], int retro[]){
	int i;
	
	for (i = 0; i < NUMNOTAS; i++){
		retro[NUMNOTAS-i-1] = fila[i];
	}
}

void trasponer(int fila[], int trasp[], int t){
	int i;
	
	for (i = 0; i < NUMNOTAS; i++){
		trasp[i] = pitchClass((fila[i] + t));
	}
}

void invertir(int fila[], int invert[]){
	int i;
	
	for (i = 0; i < NUMNOTAS; i++){
		invert[i] = pitchClass((12 - fila[i]));
	}

}

void retrogradarInvertir(int fila[], int reinv[]){

	int retro[NUMNOTAS];

	retrogradar(fila, retro);
	invertir(retro, reinv);
}
